#!/bin/bash

# Let's get some house keeping done first...
# We need to install a few packages required to get the kiosk happening.

# Functions:
# Create the activ_start.sh script

NC='\033[0m'
RED='\033[0;31m'
URED='\033[4;31m'
UWHITE='\033[4;37m'

cd ~
pwd=$(pwd)
luser=$(whoami)
chrome=$(which chromium-browser)
if [[ -z $chrome ]]; then
	chrome=$(which chromium)
fi



Activ_Start () {
	echo '#!/bin/bash' > activ_start.sh
	echo >> activ_start.sh
	echo '#functions' >> activ_start.sh
	echo >> activ_start.sh
	echo 'Dashboard () {' >> activ_start.sh
	echo 'URL=$1' >> activ_start.sh
	echo 'nohup '$chrome' --kiosk $URL & disown $!;}' >> activ_start.sh
	echo >> activ_start.sh
	echo 'xset s noblank' >> activ_start.sh
	echo 'xset s off' >> activ_start.sh
	echo 'xset -dpms' >> activ_start.sh
	echo 'unclutter -idle 0.5 -root &' >> activ_start.sh
	echo 'sed -i '\''s/"exited_cleanly":false/"exited_cleanly":true/'\' $pwd'/.config/chromium/Default/Preferences' >> activ_start.sh
	echo 'sed -i '\''s/"exit_type":"Crashed"/"exit_type":"Normal"/'\' $pwd'/.config/chromium/Default/Preferences' >> activ_start.sh
	echo >> activ_start.sh
	echo 'Dashboard "https://activ.rfs.nsw.gov.au/webapp/home"' >> activ_start.sh
	echo >> activ_start.sh
	echo 'sleep 45.0' >> activ_start.sh
	echo 'xdotool key Tab' >> activ_start.sh
	echo 'sleep 2.0' >> activ_start.sh
	echo 'xdotool key Return' >> activ_start.sh
	echo 'sleep 12.0' >> activ_start.sh
	echo 'xdotool key Tab' >> activ_start.sh
	echo 'sleep 2.0' >> activ_start.sh
	echo 'xdotool key Return' >> activ_start.sh
	echo >> activ_start.sh
	echo 'sleep 20' >> activ_start.sh
	echo 'Dashboard "https://activ.rfs.nsw.gov.au/webapp/dashboard/"' >> activ_start.sh
	echo 'while :' >> activ_start.sh
	echo 'do' >> activ_start.sh
	echo 'echo "Stay in the loop to keep Chromium running" > /dev/null 2>&1' >> activ_start.sh
	echo 'sleep 1' >> activ_start.sh
	echo 'done' >> activ_start.sh
}

Activ_Start_Service () {
	echo '[Unit]' > activ_start.service
	echo 'Description="Chromium kiosk to run RFS Activ"' >> activ_start.service
	echo 'Wants=graphical.target' >> activ_start.service
	echo 'After=graphical.target' >> activ_start.service
	echo >> activ_start.service
	echo '[Service]' >> activ_start.service
	echo 'Environment=DISPLAY=:0.0' >> activ_start.service
	echo 'Environment=XAUTHORITY='$pwd'/.Xauthority' >> activ_start.service
	echo 'Type=simple' >> activ_start.service
	echo 'ExecStart=/bin/bash '$pwd'/activ_start.sh' >> activ_start.service
	echo 'Restart=on-abort' >> activ_start.service
	echo 'User='$luser >> activ_start.service
	echo 'Group='$luser >> activ_start.service
	echo >> activ_start.service
	echo '[Install]' >> activ_start.service
	echo 'WantedBy=graphical.target' >> activ_start.service
}


clear

SUDO=''
if (( $EUID !=0 )); then
	SUDO='sudo'
fi


echo
echo "Now those apps are installed let's move on..."
echo

$SUDO apt-get update --allow-releaseinfo-change
$SUDO apt-get install -y vim xdotool unclutter sed
$SUDO apt-get update
$SUDO apt-get full-upgrade -y

$SUDO sed -i 's/#Port 22/Port 2929/' /etc/ssh/sshd_config
$SUDO sed -i 's/#PermitRootLogin prohibit-password/PermitRootLogin yes/' /etc/ssh/sshd_config
$SUDO sed -i 's/#PasswordAuthentication yes/PasswordAuthentication yes/' /etc/ssh/sshd_config

echo
echo "ssh config changed - restarting service..."
echo
$SUDO systemctl restart ssh
echo
echo "Setting the Chromium open-gl graphics options..."
$SUDO echo 'export CHROMIUM_FLAGS="$CHROMIUM_FLAGS --use-gl=egl"' > egl
$SUDO chown root. ./egl
$SUDO mv egl /etc/chromium.d/
echo
echo "Creating the bash scripts required for the kiosk service to run"
echo
Activ_Start
echo "activ_start.sh created"
echo
echo "Making the script executable"
echo
$SUDO chmod +x activ_start.sh
echo "Creating the system service that will start at boot time"
echo
Activ_Start_Service
echo
$SUDO chown root. activ_start.service
$SUDO chmod 644 activ_start.service
$SUDO mv activ_start.service /lib/systemd/system/
$SUDO systemctl enable activ_start.service
($SUDO crontab -u root -l 2>/dev/null; echo "0 0 * * * /usr/sbin/shutdown -r now") | $SUDO crontab -u root -
$SUDO crontab -l
echo "Automatic daily restart (midnight) configured in root crontab"
echo
echo -e "Please ${UWHITE}verify${NC} you have:"
echo
echo -e "       ${RED}* Connected to a network"
echo -e "       ${RED}* Signed into https://activ.rfs.nsw.gov.au at least once on this device before going ahead.${NC}"
echo -e "       ${RED}* Saved the ${URED}username and password${RED} for RFS Activ in Chromium."
echo -e "       ${RED}* ${URED}Disabled${RED} UBlock Origin in Chromium or for the Activ site - it will break the dashboard"
echo -e "       ${RED}* If you want to use the weather radar display on the dashboard - open:"
echo -e "       Chromium Settings -> Privacy and security -> Site Settings -> Additional content settings -> "
echo -e "       Insecure content: add [*.]rfs.nsw.gov.au to the \"Allowed to show insecure content\" list."
echo
echo
echo -e "       ${UWHITE}Also note${NC}: This kiosk will auto login to the RFS Activ site - it will first load the home page and 20 seconds later it will open the dashboard."
echo -e "       Once Chromium opens do not touch the mouse or keyboard."
echo
echo
echo -e "${NC}If you haven't performed these steps yet - ${UWHITE}before hitting enter${NC} - click on Chromium now, sign into RFS Activ and save the username and password when prompted."
echo -e "${NC}"
echo
echo
echo -e "If you start the service and you need to make changes to your Raspberry PI you can close Chromium by pressing Ctrl+F4"
echo
echo
echo
read -p "Press [Enter] key to start the service - this will open chromium in kiosk mode"
echo
echo
echo "Starting the Kiosk service now..."
$SUDO systemctl start activ_start.service
